#include <stdio.h>
#include <wiringPi.h>
#include "io.h"

// ピン配置
//static const int pin_sw_f  = 25;
//static const int pin_sw_l  = 21;
//static const int pin_sw_r  = 27;
//static const int pin_sw_f  = 18;
//static const int pin_sw_l  = 25;
//static const int pin_sw_r  = 26;
static const int pin_ph_l2 = 6;
static const int pin_ph_l1 = 13;
static const int pin_ph_r1 = 19;
static const int pin_ph_r2 = 26;

static const int pin_sw_f  = 4;
static const int pin_sw_l  = 7;
static const int pin_sw_r  = 8;

int io_open(){
	// GPIOデバイスのオープン
	if(wiringPiSetupGpio() != 0){
		printf("failed to open GPIO\n");
		return -1;
	}else{
		// ピン設定
		pinMode(pin_ph_l2, INPUT);
		pinMode(pin_ph_l1, INPUT);
		pinMode(pin_ph_r1, INPUT);
		pinMode(pin_ph_r2, INPUT);
		
		pinMode(pin_sw_f, INPUT);
		pinMode(pin_sw_l, INPUT);
		pinMode(pin_sw_r, INPUT);
		pullUpDnControl(pin_sw_f, PUD_UP);
		pullUpDnControl(pin_sw_l, PUD_UP);
		pullUpDnControl(pin_sw_r, PUD_UP);
		
		printf("GPIO opened\n");
		return 0;
	}
}

void io_get_sw(int *sw_f, int *sw_l, int *sw_r){
	*sw_f = digitalRead(pin_sw_f);
	*sw_l = digitalRead(pin_sw_l);
	*sw_r = digitalRead(pin_sw_r);
	printf("YOBI = %d    FALL = %d     PUSH = %d \n", *sw_f, *sw_l,*sw_r);
}

void io_get_ph(int *ph_l2, int *ph_l1, int *ph_r1, int *ph_r2){
	*ph_l2 = digitalRead(pin_ph_l2);
	*ph_l1 = digitalRead(pin_ph_l1);
	*ph_r1 = digitalRead(pin_ph_r1);
	*ph_r2 = digitalRead(pin_ph_r2);
	printf("L2 = %d    L1 = %d     R1 = %d     R2 = %d\n", *ph_l2, *ph_l1, *ph_r1, *ph_r2);
}
